﻿<?xml version="1.0" encoding="utf-8"?>
<Application>
	<DisplayInfo Title="Adobe Dimension 2019" Publisher="Adobe" Version="" ReleaseDate="">
		<UserCategories>
			<Category>Pre-Approved</Category>
		</UserCategories>
		<SoftwareCategories>
			<Category>Pre-Approved</Category>
			<Category>Adobe Creative Cloud 2019</Category>
		</SoftwareCategories>
	</DisplayInfo>
	<DeploymentType Title="" Architecture="x64" Technology="Script" DetectionMethod="Script" ContentLocation="\\server01\sources$\Adobe\Dimension\archive\{SoftwareVersion}\win_{Architecture}\">
		<UninstallCommand>"Deploy-Application.exe" UNINSTALL -InstallVersion {SoftwareVersion}</UninstallCommand>
		<InstallCommand>"Deploy-Application.exe" INSTALL -InstallVersion {SoftwareVersion}</InstallCommand>
		<Dependencies>
			<Group>
				<Application Name="Adobe Creative Cloud Desktop Application"/>
			</Group>
		</Dependencies>
		<DetectionScript RunAs32Bit="False" Language="PowerShell">
			<TEXT>$DetectionRegPath = 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall'
{DetectionStatement}

return $true
			</TEXT>
		</DetectionScript>
		<Custom>
			<DetectionScriptLogic TargetItemPath="\\server01\sources$\Adobe\Dimension\archive\{SoftwareVersion}\win_{Architecture}\Files\*.zip" >
				<SCRIPT>
$RootPath = $args[0]
$appDT = $args[1]
$appSoftwareVersion = $args[2]
$TargetItemPath = $args[3]

$sourceFile = Get-Item -Path '{DetectionScriptFilePath}'

$null = [Reflection.Assembly]::LoadWithPartialName('System.IO.Compression.FileSystem')
$zip = [IO.Compression.ZipFile]::OpenRead($sourceFile.FullName)
$parentFolder = New-Item -Path "$env:TEMP" -Name "$($sourceFile.BaseName)_Manifests" -ItemType Directory -Force
$jsonObjects = foreach($item in ($zip.Entries | Where-Object {$_.FullName -like "*/Build/HD/*/Application.json"})) {
    $parentName = $item.FullName.Split('/')[-2]
    $folder = New-Item -Path $parentFolder.FullName -Name $parentName -ItemType Directory -Force
    $null = [System.IO.Compression.ZipFileExtensions]::ExtractToFile($item, "$($folder.FullName)\$($item.Name)", $true)

    $rawJson = Get-Content -Path "$($folder.FullName)\$($item.Name)"
    $jsonObject = ConvertFrom-Json -InputObject $rawJson

    $jsonObject
}

# Close the zip
$null = $zip.Dispose()

$RegPath = 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall'

$DetectionStatement = foreach($jsonObject in ($jsonObjects | Where-Object {($_.AddRemoveInfo.DisplayName) -or ($_.IsUWPProduct -eq $true)})) {
    if($jsonObject.AddRemoveInfo.DisplayName) {
        $DetectionString = @"

# Detection for $($jsonObject.Name)
`$SAPCode = `$null
`$TargetVersion = `$null
`$SAPCode = '$($jsonObject.SAPCode)'
`$TargetVersion = '$($jsonObject.CodexVersion)'
`$RegKeyList = Get-ChildItem -Path `$DetectionRegPath | Where-Object {`$_.PSChildName -like "`$SAPCode*"}
if(`$RegKeyList) {
    `$RegKey = `$RegKeyList | Where-Object {[version]`$_.GetValue('DisplayVersion') -ge [version]`$TargetVersion}
    if(`$RegKey) {
        # Application detected
    } else {
		# Application detection failed. End script without returning anything
        break
    }
} else {
    break
}
"@

        $DetectionString
    } elseif($jsonObject.IsUWPProduct -eq $true) {

        # Reopen source zip file
        $zip = [IO.Compression.ZipFile]::OpenRead($sourceFile.FullName)

        # Find UWPAssets.zip
        if(!($zip.Entries | Where-Object {$_.FullName -like "*/Build/HD/$($jsonObject.SAPCode)$($jsonObject.CodexVersion)/UWPAssets.zip"})) {
            continue
        } else {        
            $UwpZip = $zip.Entries | Where-Object {$_.FullName -like "*/Build/HD/$($jsonObject.SAPCode)$($jsonObject.CodexVersion)/UWPAssets.zip"}

            $folder = Get-Item -Path "$($parentFolder.FullName)\$($jsonObject.SAPCode)$($jsonObject.CodexVersion)"

            # Extract to temp folder
            $null = [System.IO.Compression.ZipFileExtensions]::ExtractToFile($UwpZip, "$($folder.FullName)\$($UwpZip.Name)", $true)

            # Close source zip
            $null = $zip.Dispose()

            # Read in UwpZip
            $UwpZipFile = Get-Item -Path "$($folder.FullName)\UWPAssets.zip"
            $UwpZipContents = [IO.Compression.ZipFile]::OpenRead($UwpZipFile.FullName)

            # Get the appx info file
            $UwpAssetsXml = $UwpZipContents.Entries | Where-Object {$_.FullName -eq 'UWPAssets.pimx'}

            # Extract appx info file
            $null = [System.IO.Compression.ZipFileExtensions]::ExtractToFile($UwpAssetsXml, "$($folder.FullName)\$($UwpAssetsXml.Name)", $true)

            # Close UwpZip
            $null = $UwpZipContents.Dispose()

            # Read in appx info file
            $UwpAssetsXmlFile = Get-Item -Path "$($folder.FullName)\UWPAssets.pimx"

            # Get appx info file contents
            $UwpAssetsXmlContents = [xml](Get-Content -Path $UwpAssetsXmlFile.FullName)

            $ApplicationName = $UwpAssetsXmlContents.Package.Commands.AddUWPAppx.Name.ToString().Trim()
            $ApplicationVersion = $UwpAssetsXmlContents.Package.Commands.AddUWPAppx.Version.ToString().Trim()

            $DetectionString = @"

# Detection for $($jsonObject.Name)
`$ApplicationName = '$ApplicationName'
`$ApplicationVersion = '$ApplicationVersion'
`$AppPackageList = Get-AppxProvisionedPackage -Online | Where-Object {`$_.DisplayName -eq `$ApplicationName}

if(`$AppPackageList) {
    `$AppPackage = `$AppPackageList | Where-Object {[version]`$_.Version -ge [version]`$ApplicationVersion}
    if(`$AppPackage) {
        # Application detected
    } else {
        # Application detection failed. End script without returning anything
        break
    }
} else {
    break
}
"@

            $DetectionString
        }
    }
}

$DetectionStatement

$null = Remove-Item -Path $parentFolder.FullName -Recurse -Force
				</SCRIPT>
			</DetectionScriptLogic>
		</Custom>
	</DeploymentType>
</Application>